/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _ATTACHMENT_H_
#define _ATTACHMENT_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class AttachmentEncoding;
    class UnionOfAlarmEventJournalTodo;
    class Resource;

}

#include "resource.h"

namespace NepomukFast {

    /**
     * An object attached to a calendar entity. This class has been 
     * introduced to serve as a structured value of the ncal:attach 
     * property. See the documentation of ncal:attach for details. 
     */
    class Attachment : public NepomukFast::Resource
    {
    public:
        /**
         * Create a new empty and invalid Attachment instance
         */
        Attachment( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'attachmentUri'. The uri of the attachment. Created 
         * to express the actual value of the ATTACH property defined in 
         * RFC 2445 sec. 4.8.1.1. This property expresses the default 
         * URI datatype of that property. see ncal:attachmentContents 
         * for the BINARY datatype. 
         */
        void setAttachmentUris( const QList<Resource>& value );

        /**
         * Add a value to property 'attachmentUri'. The uri of the attachment. 
         * Created to express the actual value of the ATTACH property defined 
         * in RFC 2445 sec. 4.8.1.1. This property expresses the default 
         * URI datatype of that property. see ncal:attachmentContents 
         * for the BINARY datatype. 
         */
        void addAttachmentUri( const Resource& value );

        /**
         * \return The URI of the property 'attachmentUri'. 
         */
        static QUrl attachmentUriUri();

        /**
         * Set property 'fmttype'. To specify the content type of a referenced 
         * object. Inspired by RFC 2445 sec. 4.2.8. The value of this property 
         * should be an IANA-registered content type (e.g. application/binary) 
         */
        void setFmttypes( const QStringList& value );

        /**
         * Add a value to property 'fmttype'. To specify the content type 
         * of a referenced object. Inspired by RFC 2445 sec. 4.2.8. The 
         * value of this property should be an IANA-registered content 
         * type (e.g. application/binary) 
         */
        void addFmttype( const QString& value );

        /**
         * \return The URI of the property 'fmttype'. 
         */
        static QUrl fmttypeUri();

        /**
         * Set property 'attachmentContent'. The uri of the attachment. 
         * Created to express the actual value of the ATTACH property defined 
         * in RFC 2445 sec. 4.8.1.1. This property expresses the BINARY 
         * datatype of that property. see ncal:attachmentUri for the 
         * URI datatype. 
         */
        void setAttachmentContents( const QStringList& value );

        /**
         * Add a value to property 'attachmentContent'. The uri of the 
         * attachment. Created to express the actual value of the ATTACH 
         * property defined in RFC 2445 sec. 4.8.1.1. This property expresses 
         * the BINARY datatype of that property. see ncal:attachmentUri 
         * for the URI datatype. 
         */
        void addAttachmentContent( const QString& value );

        /**
         * \return The URI of the property 'attachmentContent'. 
         */
        static QUrl attachmentContentUri();

        /**
         * Set property 'encoding'. To specify an alternate inline encoding 
         * for the property value. Inspired by RFC 2445 sec. 4.2.7. Originally 
         * this property had a limited vocabulary. ('8BIT' and 'BASE64'). 
         * The terms of this vocabulary have been expressed as instances 
         * of the AttachmentEncoding class 
         */
        void setEncodings( const QList<AttachmentEncoding>& value );

        /**
         * Add a value to property 'encoding'. To specify an alternate 
         * inline encoding for the property value. Inspired by RFC 2445 
         * sec. 4.2.7. Originally this property had a limited vocabulary. 
         * ('8BIT' and 'BASE64'). The terms of this vocabulary have been 
         * expressed as instances of the AttachmentEncoding class 
         */
        void addEncoding( const AttachmentEncoding& value );

        /**
         * \return The URI of the property 'encoding'. 
         */
        static QUrl encodingUri();



    protected:
        Attachment( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
