/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _CALENDAR_H_
#define _CALENDAR_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class CalendarDataObject;
    class CalendarScale;

}

#include "informationelement.h"

namespace NepomukFast {

    /**
     * A calendar. Inspirations for this class can be traced to the 
     * VCALENDAR component defined in RFC 2445 sec. 4.4, but it may 
     * just as well be used to represent any kind of Calendar. 
     */
    class Calendar : public InformationElement
    {
    public:
        /**
         * Create a new empty and invalid Calendar instance
         */
        Calendar( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'component'. Links the Vcalendar instance with 
         * the calendar components. This property has no direct equivalent 
         * in the RFC specification. It has been introduced to express 
         * the containmnent relations. 
         */
        void setComponents( const QList<CalendarDataObject>& value );

        /**
         * Add a value to property 'component'. Links the Vcalendar instance 
         * with the calendar components. This property has no direct equivalent 
         * in the RFC specification. It has been introduced to express 
         * the containmnent relations. 
         */
        void addComponent( const CalendarDataObject& value );

        /**
         * \return The URI of the property 'component'. 
         */
        static QUrl componentUri();

        /**
         * Set property 'prodid'. This property specifies the identifier 
         * for the product that created the iCalendar object. Defined 
         * in RFC 2445 sec. 4.7.2 
         */
        void setProdids( const QStringList& value );

        /**
         * Add a value to property 'prodid'. This property specifies the 
         * identifier for the product that created the iCalendar object. 
         * Defined in RFC 2445 sec. 4.7.2 
         */
        void addProdid( const QString& value );

        /**
         * \return The URI of the property 'prodid'. 
         */
        static QUrl prodidUri();

        /**
         * Set property 'method'. This property defines the iCalendar 
         * object method associated with the calendar object. Defined 
         * in RFC 2445 sec. 4.7.2 
         */
        void setMethods( const QStringList& value );

        /**
         * Add a value to property 'method'. This property defines the 
         * iCalendar object method associated with the calendar object. 
         * Defined in RFC 2445 sec. 4.7.2 
         */
        void addMethod( const QString& value );

        /**
         * \return The URI of the property 'method'. 
         */
        static QUrl methodUri();

        /**
         * Set property 'calscale'. This property defines the calendar 
         * scale used for the calendar information specified in the iCalendar 
         * object. Defined in RFC 2445 sec. 4.7.1 
         */
        void setCalscales( const QList<CalendarScale>& value );

        /**
         * Add a value to property 'calscale'. This property defines the 
         * calendar scale used for the calendar information specified 
         * in the iCalendar object. Defined in RFC 2445 sec. 4.7.1 
         */
        void addCalscale( const CalendarScale& value );

        /**
         * \return The URI of the property 'calscale'. 
         */
        static QUrl calscaleUri();

        /**
         * Set property 'version'. This property specifies the identifier 
         * corresponding to the highest version number or the minimum 
         * and maximum range of the iCalendar specification that is required 
         * in order to interpret the iCalendar object. Defined in RFC 2445 
         * sec. 4.7.4 
         */
        void setVersions( const QStringList& value );

        /**
         * Add a value to property 'version'. This property specifies 
         * the identifier corresponding to the highest version number 
         * or the minimum and maximum range of the iCalendar specification 
         * that is required in order to interpret the iCalendar object. 
         * Defined in RFC 2445 sec. 4.7.4 
         */
        void addVersion( const QString& value );

        /**
         * \return The URI of the property 'version'. 
         */
        static QUrl versionUri();



    protected:
        Calendar( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
