/*
 * This file is part of the Nepomuk KDE project.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

/*
 * This file has been generated by the Nepomuk Resource class generator.
 * DO NOT EDIT THIS FILE.
 * ANY CHANGES WILL BE LOST.
 */

#ifndef _NCALDATETIME_H_
#define _NCALDATETIME_H_

class QDateTime;
class QDate;
class QTime;

namespace NepomukFast {
    class Todo;
    class RecurrenceIdentifier;
    class UnionOfEventFreebusy;
    class UnionOfTimezoneObservanceEventFreebusyTimezoneTodo;
    class Timezone;
    class UnionOfEventJournalTimezoneTodo;

}

#include "ncaltimeentity.h"

namespace NepomukFast {


    class NcalDateTime : public NcalTimeEntity
    {
    public:
        /**
         * Create a new empty and invalid NcalDateTime instance
         */
        NcalDateTime( const QUrl &uri = QUrl(), const QUrl &graphUri = QUrl() );

        /**
         * Set property 'ncalTimezone'. The timezone instance that should 
         * be used to interpret an NcalDateTime. The purpose of this property 
         * is similar to the TZID parameter specified in RFC 2445 sec. 4.2.19 
         */
        void setNcalTimezones( const QList<Timezone>& value );

        /**
         * Add a value to property 'ncalTimezone'. The timezone instance 
         * that should be used to interpret an NcalDateTime. The purpose 
         * of this property is similar to the TZID parameter specified 
         * in RFC 2445 sec. 4.2.19 
         */
        void addNcalTimezone( const Timezone& value );

        /**
         * \return The URI of the property 'ncalTimezone'. 
         */
        static QUrl ncalTimezoneUri();

        /**
         * Set property 'date'. Date an instance of NcalDateTime refers 
         * to. It was conceived to express values in DATE datatype specified 
         * in RFC 2445 4.3.4 
         */
        void setDates( const QList<QDate>& value );

        /**
         * Add a value to property 'date'. Date an instance of NcalDateTime 
         * refers to. It was conceived to express values in DATE datatype 
         * specified in RFC 2445 4.3.4 
         */
        void addDate( const QDate& value );

        /**
         * \return The URI of the property 'date'. 
         */
        static QUrl dateUri();

        /**
         * Set property 'dateTime'. Representation of a date an instance 
         * of NcalDateTime actually refers to. It's purpose is to express 
         * values in DATE-TIME datatype, as defined in RFC 2445 sec. 4.3.5 
         */
        void setDateTimes( const QList<QDateTime>& value );

        /**
         * Add a value to property 'dateTime'. Representation of a date 
         * an instance of NcalDateTime actually refers to. It's purpose 
         * is to express values in DATE-TIME datatype, as defined in RFC 
         * 2445 sec. 4.3.5 
         */
        void addDateTime( const QDateTime& value );

        /**
         * \return The URI of the property 'dateTime'. 
         */
        static QUrl dateTimeUri();



    protected:
        NcalDateTime( const QUrl& uri, const QUrl& graphUri, const QUrl& type );
    };
}

#endif
